.486
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include ReadRegKey.inc

.data
    lpszComputerNameSubKey		DB  "SYSTEM\CurrentControlSet\Control\ComputerName\ComputerName",0
    lpszComputerNameValueName   DB  "ComputerName",0
	szMBCapt					DB	"Registry Error",0
	szNoFindKey					DB	"Key not present.",0
	szNoFindVal					DB	"Value not present.",0

.data?
    lpbData		DD 256 Dup (?)
    lpcbData    DD  ?
    lpdwType    DD  ?
	VBufLen		dd	?
	Buffer		db 1024 dup(?)
	wdat		WSADATA <?>
    getip		PROTO
    lpbIP		DD ?
.code

start:
	invoke	GetModuleHandle,NULL
	mov	hInstance,eax
	invoke	InitCommonControls
	invoke	FindComputerName
	invoke	getip
	invoke	DialogBoxParam,hInstance,IDD_MAIN,NULL,addr DlgProc,NULL
	invoke	ExitProcess,0

;########################################################################


DlgProc	proc	hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	mov	eax,uMsg
	.if	eax==WM_INITDIALOG
		;initialization here
	    INVOKE SendDlgItemMessage,hWin,103,WM_SETTEXT, 0, OFFSET lpbData+NULL
	    INVOKE SendDlgItemMessage,hWin,105,WM_SETTEXT, 0, DWORD PTR [lpbIP]+NULL
	.elseif	eax==WM_COMMAND
		mov edx,wParam
		movzx eax,dx
		shr edx,16
		.if edx==BN_CLICKED
			.if eax==IDOK
				invoke	SendMessage,hWin,WM_CLOSE,NULL,NULL
			.elseif eax==IDCANCEL
				invoke	SendMessage,hWin,WM_CLOSE,NULL,NULL
			.endif
		.endif
	.elseif	eax==WM_CLOSE
		invoke	EndDialog,hWin,0
	.else
		mov	eax,FALSE
		ret
	.endif
	mov	eax,TRUE
	ret
DlgProc endp
getip proc
    invoke WSAStartup,101h,addr wdat
    invoke gethostbyname,addr lpbData
    mov eax, DWORD PTR [eax+12]
    mov eax, DWORD PTR [eax]          
    mov eax, DWORD PTR [eax]
    invoke inet_ntoa,eax
    mov DWORD PTR [lpbIP],eax
	invoke WSACleanup
    ret  
getip endp

FindComputerName proc
	LOCAL hKey:DWORD
	pusha
	invoke RegOpenKeyEx,HKEY_LOCAL_MACHINE,addr lpszComputerNameSubKey,0,KEY_QUERY_VALUE,addr hKey
    or eax,eax
    jnz ComputerNameKeyNotFound
    mov VBufLen,sizeof Buffer
    invoke RegQueryValueEx,hKey,addr lpszComputerNameValueName,0,addr lpdwType,addr lpbData,addr VBufLen
    cmp eax,ERROR_SUCCESS
    jne ComputerNameValNotFound
    Invoke RegCloseKey,hKey
    jmp ComputerNameEndKey
ComputerNameKeyNotFound:
    INVOKE MessageBox,NULL,addr szNoFindKey,addr szMBCapt,MB_OK
    jmp ComputerNameEndKey
ComputerNameValNotFound:
    INVOKE MessageBox,NULL,addr szNoFindVal,addr szMBCapt,MB_OK
    Invoke RegCloseKey,hKey
ComputerNameEndKey:
	popa
	ret
FindComputerName endp
end start